﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Reflection;
using System.Xml.Serialization;
using System.IO;
using System.Windows.Forms;
using System.Net;
using System.Net.NetworkInformation;
using System.Diagnostics;

namespace HKFmonitor
{
    public class Configuration
    {
        public Configuration()
        {
            this.appStart = Assembly.GetExecutingAssembly().Location.Substring(0, Assembly.GetExecutingAssembly().Location.LastIndexOf('\\'));
        }

        internal string appversion = "2.0";
        internal string appStart = "";
        internal string phpAddr = "http://lide.hkfree.org/~creative/zk/hkfmon.php";
        public string checkAddress = "8.8.8.8";
        public string checkGWaddress = "10.107.4.100";
        public string myAddress = "";
        public string openIP = "*";
        public int openPort = 5000;
        public int serverPort = 5000;
        public bool popUpMsg = true;
        public string updateAddr = "http://lide.hkfree.org/~creative/zk/updates/";
        public string speedtestAddr1M = "http://lide.hkfree.org/~creative/zk/speedtest/1mbfile.txt";
        public string speedtestAddr10M = "http://lide.hkfree.org/~creative/zk/speedtest/10mbfile.txt";
        public int intMessages = 10000;
        public int intUpdates = 10000;
        public int intOnline = 5000;
        public bool autoUpdate = true;
        public int clientsChecksum = 1;
        public int technicsChecksume = 1;
        public List<string> myRoute;
        public List<technician> technics;
        public List<string> clients;


        public string getMyIP()
        {
            return WebComm.fastPHPpost(phpAddr, "myip");
        }

        public List<string> getTraceroute(string ipAddressOrHostName, bool extended)
        {
            try
            {
                IPAddress ipAddress = Dns.GetHostEntry(ipAddressOrHostName).AddressList[0];
                List<string> tracert = new List<string>();
                tracert.Clear();

                using (Ping pingSender = new Ping())
                {
                    PingOptions pingOptions = new PingOptions();
                    Stopwatch stopWatch = new Stopwatch();
                    byte[] bytes = new byte[32];

                    pingOptions.DontFragment = true;
                    pingOptions.Ttl = 1;
                    int maxHops = 30;
                    int fails = 0;

                    for (int i = 1; i < maxHops + 1; i++)
                    {
                        stopWatch.Reset();
                        stopWatch.Start();
                        PingReply pingReply = pingSender.Send(
                            ipAddress,
                            5000,
                            new byte[32], pingOptions);
                        stopWatch.Stop();


                        if (pingReply.Address != null)
                        {
                            string pr = pingReply.Address.ToString();
                            //zde zastavím cyklus pokud tracert vrací pořád to samé
                            if (tracert.Contains(pr)) break;
                            tracert.Add(pr);
                            if (fails > 4) break;
                            fails++;
                            
                        }

                        if (pingReply.Status == IPStatus.Success)
                        {
                            break;
                        }
                        pingOptions.Ttl++;
                    }
                }
                return tracert;
            }
            catch (Exception)
            {
                return null;
            }
        }

        public string Ping(string ipAddressString)
        {
            using (Ping pingSender = new Ping())
            {
                PingOptions pingOptions = null;
                StringBuilder pingResults = null;
                PingReply pingReply = null;
                IPAddress ipAddress = null;
                int numberOfPings = 4;
                int pingTimeout = 1000;
                int byteSize = 32;
                byte[] buffer = new byte[byteSize];
                int sentPings = 0;
                int receivedPings = 0;
                int lostPings = 0;
                long minPingResponse = 0;
                long maxPingResponse = 0;
                pingOptions = new PingOptions();
                ipAddress = IPAddress.Parse(ipAddressString);
                pingResults = new StringBuilder();
                pingResults.AppendLine(string.Format("Pinging {0} with {1} bytes of data:", ipAddress, byteSize));
                pingResults.AppendLine();
                for (int i = 0; i < numberOfPings; i++)
                {
                    sentPings++;
                    pingReply = pingSender.Send(ipAddress, pingTimeout, buffer, pingOptions);
                    if (pingReply.Status == IPStatus.Success)
                    {
                        pingResults.AppendLine(string.Format("Reply from {0}: bytes={1} time={2}ms TTL={3}", ipAddress, byteSize, pingReply.RoundtripTime, pingReply.Options.Ttl));
                        if (minPingResponse == 0)
                        {
                            minPingResponse = pingReply.RoundtripTime;
                            maxPingResponse = minPingResponse;
                        }
                        else if (pingReply.RoundtripTime < minPingResponse)
                        {
                            minPingResponse = pingReply.RoundtripTime;
                        }
                        else if (pingReply.RoundtripTime > maxPingResponse)
                        {
                            maxPingResponse = pingReply.RoundtripTime;
                        }
                        receivedPings++;
                    }
                    else
                    {
                        pingResults.AppendLine(pingReply.Status.ToString());
                        lostPings++;
                    }
                }
                pingResults.AppendLine();
                pingResults.AppendLine(string.Format("Ping statistics for {0}:", ipAddress));
                pingResults.AppendLine(string.Format("\tPackets: Sent = {0}, Received = {1}, Lost = {2}", sentPings, receivedPings, lostPings));
                pingResults.AppendLine("Approximate round trip times in milli-seconds:");
                pingResults.AppendLine(string.Format("\tMinimum = {0}ms, Maximum = {1}ms", minPingResponse, maxPingResponse));
                return pingResults.ToString();
            }
        }

        public string getDefaultGateway(string gwFromTraceroute)
        {
            //z důvodu možnosti více GW v PC porovnávám s tou co je v tracertu
            var networkCards = NetworkInterface.GetAllNetworkInterfaces();
            if (networkCards == null) return null;
            List<string> tmpGWs = new List<string>();
            foreach (NetworkInterface ni in networkCards)
            {
                try
                {
                    tmpGWs.Add(ni.GetIPProperties().GatewayAddresses.FirstOrDefault().Address.ToString());
                }
                catch (Exception)
                {
                }
            }
            foreach (string s in tmpGWs)
            {
                if (s == gwFromTraceroute) return s;
            }
            return null;
        }

        internal void saveConfiguration()
        {


            XmlSerializer xmls = new XmlSerializer(this.GetType());
            try
            {
                FileStream fs = new FileStream(Assembly.GetExecutingAssembly().CodeBase.Replace(".EXE", ".ini").Replace(".exe", ".ini").Replace("file:///", "").Replace("file:", "").Replace("/", "\\"), FileMode.Create, FileAccess.Write);
                xmls.Serialize(fs, this);
                fs.Close();

            }
            catch (Exception ex)
            {
                MessageBox.Show("Chyba při ukládání konfigurace" + Environment.NewLine + ex.Message);
            }

        }

        internal int tryParseInt(string num)
        {
            try
            {
                return int.Parse(num);
            }
            catch
            {
                return -1;
            }
        }

        internal string ms2text(int ms)
        {
            ms = ms / 1000;
            return ms.ToString();
        }

        internal int text2ms(string text)
        {
            int ms = tryParseInt(text);
            return ms * 1000;
        }

        internal long tryParseLong(string num)
        {
            try
            {
                return long.Parse(num);
            }
            catch
            {
                return -1;
            }
        }

        internal DateTime tryParseDate(string dt)
        {
            try
            {
                return DateTime.ParseExact(dt, "d. M. yyyy h:mm:ss", null);
            }
            catch
            {
                try
                {
                    return DateTime.ParseExact(dt, "d.M.yyyy h:mm:ss", null);
                }
                catch
                {
                    try
                    {
                        return DateTime.ParseExact(dt, "yyyy-MM-dd", null);
                    }
                    catch
                    {
                        return DateTime.MaxValue;
                    }
                }

            }
        }

        internal double tryParseDouble(string num)
        {
            try
            {
                return double.Parse(num.Replace('.', ','));
            }
            catch
            {
                return 0;
            }
        }

        internal bool tryParseBool(string num)
        {

            if (num.ToLower() == "false" || num == "0")
                return false;
            else
                return true;


        }
    }


}
