﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Reflection;
using System.IO;
using NetFwTypeLib;

namespace HKFmonitor
{
    public partial class frmCfg : Form
    {
        Configuration conf;

        public frmCfg(Configuration conf)
        {
            InitializeComponent();
            this.conf = conf;
            tbIntMess.Text = conf.ms2text(conf.intMessages);
            tbIntOnline.Text = conf.ms2text(conf.intOnline);
            tbIntUpdates.Text = conf.ms2text(conf.intUpdates);
        }

        private void btClose_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void btSave_Click(object sender, EventArgs e)
        {
            conf.intMessages = conf.text2ms(tbIntMess.Text);
            conf.intOnline = conf.text2ms(tbIntOnline.Text);
            conf.intUpdates = conf.text2ms(tbIntUpdates.Text);
            conf.saveConfiguration();
            this.Close();
        }

        private void frmCfg_Load(object sender, EventArgs e)
        {
            lbHKFip.Text = conf.myAddress;
        }

        private void btDelCfg_Click(object sender, EventArgs e)
        {
            string tmpPath = conf.appStart;
            if (File.Exists(tmpPath + "\\HKFmonitor.ini"))
            {
                try
                {
                    File.Delete(tmpPath + "\\HKFmonitor.ini");
                }
                catch (Exception)
                {
                }
            }
            if (File.Exists(tmpPath + "\\HKFmonitor.msg"))
            {
                try
                {
                    File.Delete(tmpPath + "\\HKFmonitor.msg");
                }
                catch (Exception)
                {
                }
            }
        }

        private void btFirewall_Click(object sender, EventArgs e)
        {
            try
            {
                INetFwRule firewallRule = (INetFwRule)Activator.CreateInstance(Type.GetTypeFromProgID("HNetCfg.FWRule"));
                firewallRule.Action = NET_FW_ACTION_.NET_FW_ACTION_ALLOW;
                firewallRule.Description = "HKFree monitor";
                firewallRule.ApplicationName = conf.appStart + "\\HKFmonitor.exe";
                firewallRule.Enabled = true;
                firewallRule.InterfaceTypes = "All";
                firewallRule.Name = "HKFmonitor";

                INetFwPolicy2 firewallPolicy = (INetFwPolicy2)Activator.CreateInstance(
                    Type.GetTypeFromProgID("HNetCfg.FwPolicy2"));
                firewallPolicy.Rules.Add(firewallRule);
            }
            catch (Exception)
            {
                MessageBox.Show("Nelze přidat vyjímku, musíte spustit aplikaci jako správce!");
            }
        }
    }
}
