﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net.Mail;

namespace HKFmonitor
{
    public partial class frmSendDiag : Form
    {
        Configuration conf;
        frmDiagnostics diag;

        public frmSendDiag(Configuration conf, frmDiagnostics diag)
        {
            InitializeComponent();
            this.conf = conf;
            this.diag = diag;

            lbSubject.Text = "[HKFmon IP: " + conf.myAddress + "] Výpis diagnostiky";

            cbEamail.Items.Add("podpora.hkfree.org");
            foreach (technician t in conf.technics)
            {
                cbEamail.Items.Add(t.email);
            }
            cbEamail.SelectedIndex = 0;

            fillText();
        }

        private void fillText()
        {
            tbText.Text = "Toto je automaticky generovaný diagnostický obsah z aplikace HKFree monitor" + Environment.NewLine;
            tbText.AppendText(Environment.NewLine + "Dostupnost internetu: " + diag.oNet);
            tbText.AppendText(Environment.NewLine + "Dostupnost hlavního počítače HKFree: " + diag.oHKF);
            tbText.AppendText(Environment.NewLine + "Dostupnost první brány v síti HKFree: " + diag.oHGW);
            tbText.AppendText(Environment.NewLine + "Dostupnost brány vašeho PC: " + diag.oPCGW);
            if (diag.oHKF == "ANO")
            {
                tbText.AppendText(Environment.NewLine + "--------------------------------------------------");
                tbText.AppendText(Environment.NewLine + Environment.NewLine + "Test rychlosti se souborem o velikosti 1MB" + Environment.NewLine + diag.lbSpeed.Text);
            }
            tbText.AppendText(Environment.NewLine + "--------------------------------------------------");
            tbText.AppendText(Environment.NewLine + Environment.NewLine + "Výpis trasy do internetu:" + Environment.NewLine + diag.tbTraceroute.Text);
            tbText.AppendText(Environment.NewLine + "--------------------------------------------------");
            tbText.AppendText(Environment.NewLine + Environment.NewLine + "Dostupnost brány vašeho PC:" + Environment.NewLine + diag.tbPingGWpc.Text);
            tbText.AppendText(Environment.NewLine + "--------------------------------------------------");
            tbText.AppendText(Environment.NewLine + Environment.NewLine + "Dostupnost první brány v síti HKFree:" + Environment.NewLine + diag.tbPingNGW.Text);
            tbText.AppendText(Environment.NewLine + "--------------------------------------------------");
            tbText.AppendText(Environment.NewLine + Environment.NewLine + "Dostupnost hlavního počítače HKFree:" + Environment.NewLine + diag.tbPingMain.Text);
            tbText.AppendText(Environment.NewLine + "--------------------------------------------------");
            tbText.AppendText(Environment.NewLine + Environment.NewLine + "Dostupnost internetu:" + Environment.NewLine + diag.tbPingInternet.Text);

        }

        private void frmSendDiag_Load(object sender, EventArgs e)
        {

        }

        private void btClose_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private bool sendEmail()
        {
            try
            {
                MailMessage message = new MailMessage("HKFmon-" + conf.myAddress + "@hkfree.org", cbEamail.SelectedItem.ToString(), "[HKFmon IP: " + conf.myAddress + "] Výpis diagnostiky", tbText.Text);
                SmtpClient client = new SmtpClient("smtp.hkfree.org");
                client.Send(message);
                return true;
            }
            catch (Exception)
            {
                return false;
            }

        }

        private void btSend_Click(object sender, EventArgs e)
        {
            if (sendEmail() == true)
            {
                tbText.Text = "";
                MessageBox.Show("Zpráva byla odeslána.");
            }
            else MessageBox.Show("Zprávu se nepodařilo odeslat!");
        }
    }
}
