﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.IO;
using System.Diagnostics;
using System.Threading;

namespace HKFmonitor
{
    public partial class frmUpdate : Form
    {
        Configuration conf;
        WebClient wc;
        Updates upd;

        public frmUpdate(Configuration conf)
        {
            this.conf = conf;
            wc = new WebClient();
            upd = new Updates();
            InitializeComponent();
            btDoUpdate.Enabled = false;
            lbOldVer.Text = conf.appversion;
            lbNewVer.Text = "?";
            cbAutoUpdate.Checked = conf.autoUpdate;
            lbStatus.Text = null;
        }

        private void checkVersion()
        {
            string newVer = upd.checkVersion(conf.updateAddr, conf.appversion);
            if (newVer != null)
            {
                lbNewVer.Text = newVer;
                lbStatus.Text = "Je k dispozici nová verze programu";
                btDoUpdate.Enabled = true;
            }
            else
            {
                lbNewVer.Text = conf.appversion;
                lbStatus.Text = "Používáte aktuální verzi.";
                btDoUpdate.Enabled = false;
            }
        }

        private void btClose_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void btCheckV_Click(object sender, EventArgs e)
        {
            checkVersion();
        }

        private void btDoUpdate_Click(object sender, EventArgs e)
        {
            upd.performUpdate(false, conf.updateAddr);
        }

        private void btSave_Click(object sender, EventArgs e)
        {
            conf.autoUpdate = cbAutoUpdate.Checked;
            conf.saveConfiguration();
            this.Close();
        }

        private void frmUpdate_Load(object sender, EventArgs e)
        {

        }
    }
}
