﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net;
using System.Diagnostics;
using System.Windows.Forms;
using System.IO;
using System.Threading;

namespace HKFmonitor
{
    
    class Updates
    {
        public string checkVersion(string updateAddr, string appversion)
        {
            WebClient wc = new WebClient();
            try
            {
                string newVer = wc.DownloadString(updateAddr + "version.txt");
                if (newVer != appversion)
                {
                    return newVer;
                }
                else return null;
            }
            catch (Exception)
            {
                return null;
            }
        }

        public void performUpdate(bool silent, string updateAddr)
        {
            string result = downloadUpdater(silent, updateAddr);
            if (result == "OK")
            {
                result = downloadUpdateFile(silent, updateAddr);
                if (result == "OK")
                {
                    try
                    {
                        Process.Start(Application.StartupPath + "\\update\\HKFmonUpdater.exe", "''");
                        Application.Exit();
                    }
                    catch (Exception)
                    {
                        if (!silent) MessageBox.Show("Nelze spustit aktualizační program!");
                    }
                }
                else
                {
                    if (!silent) MessageBox.Show("Nepodařilo se stáhnout aktualizační balíček!");
                }
            }
            else
            {
                if (!silent) MessageBox.Show("Nepodařilo se stáhnout aktualizační nástroj!");
                return;
            }
        }

        private string downloadUpdater(bool silent, string updateAddr)
        {
            WebClient wc = new WebClient();
            try
            {
                foreach (Process p in System.Diagnostics.Process.GetProcessesByName("HKFmonUpdater"))
                {
                    try
                    {
                        p.Kill();
                        p.WaitForExit();
                    }
                    catch
                    {
                    }
                }
                if (System.Diagnostics.Process.GetProcessesByName("HKFmonUpdater").Length > 0)
                {
                    if (!silent) throw new Exception("Aktualizační nástroj HKFmonUpdater je již spuštěn, ukončete jej prosím!");
                }
                string updater = Application.StartupPath + "\\update\\HKFmonUpdater.exe";
                int count = 0;
                while (count < 3 && File.Exists(updater))
                {
                    try
                    {
                        File.Delete(updater);
                    }
                    catch
                    {
                    }
                    Thread.Sleep(300);
                    count++;
                }
                if (File.Exists(updater))
                {
                    if (!silent) MessageBox.Show("Chyba při mazání aktualizačního nástroje HKFmonUpdater, zkontrolujte prosím práva!");
                }

                if (!Directory.Exists(Application.StartupPath + "\\update")) Directory.CreateDirectory(Application.StartupPath + "\\update");

                string fileToDown = updateAddr + "HKFmonUpdater.exe";
                while (!File.Exists(updater) && count < 3)
                {
                    try
                    {
                        wc.DownloadFile(fileToDown, updater);
                    }
                    catch
                    {
                    }
                    Thread.Sleep(300);
                    count++;
                }
                if (!File.Exists(updater) && count == 3)
                {
                    if (!silent) MessageBox.Show("Nepodařilo se stáhnout aktualizační nástroj HKFmonUpdater.");
                }

                return "OK";
            }
            catch (Exception ex)
            {
                return ex.Message;
            }


        }

        private string downloadUpdateFile(bool silent, string updateAddr)
        {
            WebClient wc = new WebClient();
            try
            {
                string updater = Application.StartupPath + "\\update\\HKFmonitor.upd";
                int count = 0;
                while (count < 3 && File.Exists(updater))
                {
                    try
                    {
                        File.Delete(updater);
                    }
                    catch
                    {
                    }
                    Thread.Sleep(300);
                    count++;
                }
                if (File.Exists(updater))
                {
                    if (!silent) MessageBox.Show("Chyba při mazání předchozího aktualizačního balíčku, zkontrolujte prosím práva!");
                }

                string fileToDown = updateAddr + "HKFmonitor.upd";
                while (!File.Exists(updater) && count < 3)
                {
                    try
                    {
                        wc.DownloadFile(fileToDown, updater);
                    }
                    catch
                    {
                    }
                    Thread.Sleep(300);
                    count++;
                }
                if (!File.Exists(updater) && count == 3)
                {
                    if (!silent) MessageBox.Show("Nepodařilo se stáhnout aktualizační balíček.");
                }

                return "OK";
            }
            catch (Exception ex)
            {
                return ex.Message;
            }


        }
    }
}
